;=== 1===
;high 1101 0001				; 101
;low  1100 0100

.include "c:\SOFT\MCU\AVR\def\m8def.inc" 	; 102
.CSEG
.org 0					; 103
	rjmp	RESET  ;Reset Handler
	nop	;rjmp	EXT_INT0	
	nop	;rjmp	EXT_INT1	
	nop	;rjmp	TIM2_COMP	
	nop	;rjmp	TIM2_OVF	
	nop	;rjmp	TIM1_CAPT	
	nop	;rjmp	TIM1_COMPA	
	nop	;rjmp	TIM1_COMPB	
	nop	;rjmp	TIM1_OVF	
	nop	;rjmp	TIM0_OVF	
	nop	;rjmp	SPI_STC		
	nop	;rjmp	U_RXC 		
	nop	;rjmp	USART_DRE	
	nop	;rjmp	USART_TXC	
	nop	;rjmp	ADC_I		
	nop	;rjmp	EE_RDY		
	nop	;rjmp	ANA_COMP	
	nop	;rjmp	TWI		
	nop	;rjmp	SPM_RDY		

;   :
.def	aBank1	=r2
.def	aBank2	=r3
.def	pLo	=r4
.def	pHi	=r5
.def	addrWr	=r6
.def	addrX	=r8	; X 

.def	tmp	=r16
.def	addrY	=r17	; Y 
.def	cnt	=r18
.def	TWData	=r19	;   TWI
.def	TWStat	=r20	; TWI

.def	cnt1	=r22
.def	tm2	=r23
.def	datrs	=r24

.equ	aCmd	=$0060
.equ	aData	=$0070

RESET:	ldi	tmp,low(RAMEND)	 
	out	SPL,tmp 	;	
	ldi	tmp,high(RAMEND)
	out	SPH,tmp
ldi	tmp,(1<<WDE)|(1<<WDCE)
out	WDTCR,tmp
ldi	tmp,(1<<WDE)|7	;WatchDog=2
	out	WDTCR,tmp
	wdr
	ser	tmp
	out	DDRB,tmp
	out	DDRC,tmp	; TWI: PC3PC5
	cbi	DDRC,PC4	; 104
	out	PORTC,tmp
	out	PORTB,tmp
	out	PORTD,tmp
	out	DDRD,tmp
	cbi	DDRD,PD3
	cbi	PORTD,PD3
	
	ldi	XH,high(aCmd)
	ldi	XL,low(aCmd)

	ldi	tmp,10		; 105
	out	TWBR,tmp
	ser	tmp
	out	TWDR,tmp
	ldi	tmp,1<<TWEN
	out	TWCR,tmp
	rcall	DisplayRst	; 106	
	rcall	DisplayIni	; 107
	rcall	ClrScr		; 108
;  :
	ldi	addrY,4
	rcall	SetAddr
	ldi ZH, high(e0<<1)
	ldi ZL, low (e0<<1)
 rcall	WrData		; 109
;  :
	ldi	addrY,0
	rcall	SetAddr
 rcall	ShowLine	; 110
 rcall	Invert		; 111
; rcall	UnInvert		; 112

cycle:	wdr			; 113
	rjmp	cycle

.include "TW.inc"			; 114
;=^= 1=^=


;=== 3===
DisplayRst:	; 		;301
	cbi	PORTC,PC3
	ldi	cnt,20
DRst:	dec	cnt
	brne	DRst
	wdr
	sbi	PORTC,PC3
	ret
;===================		
DisplayCh:				;302
	lpm	datrs, Z
	adiw	ZL,1 
	rcall	WrBt2C
	ret
;======
WrData:	rcall	TWWrAddr		;303
	ldi	datrs,$40	
	rcall	WrBt2C
	ldi	cnt,16*6			;304 
nextCh:	rcall	DisplayCh
	dec	cnt
	brne	nextCh

	rcall	TWStop
	ret
;============
TWWrAddr:				;305
	rcall	TWStart
	ldi	TWData,aWr2C
	ldi	TWStat,MT_SLA_ACK
	rcall	TWDataTrns
	ret
;====================
WrBt2C:	mov	TWData,datrs		;306
	ldi	TWStat,MT_DATA_ACK
	rcall	TWDataTrns
	ret
;===============
ClrScr:	ldi	r31,9			;307
	rcall	TWWrAddr
	ldi	datrs,$40	; 
	rcall	WrBt2C
CS1:	ldi	cnt,102	
CS2:	clr	datrs
	rcall	WrBt2C
	dec	cnt
	brne	CS2
	wdr
	dec	r31
	brne	CS1
	rcall	TWStop
	ret
;===============
SetXAddr:				;308
	rcall	TWWrAddr	;Start, Slave Addr
	ldi	datrs,$00	;.:C0,D/C =0
	rcall	WrBt2C
	ldi	datrs,FuncSet|(0<<H)	;H=0
	rcall	WrBt2C
	ldi	datrs,setX
	add	datrs,addrX	; X
	rcall	WrBt2C
	rcall	TWStop
	ret
;=======
SetYAddr:				;309
	andi	addrY,$0f
	rcall	TWWrAddr	;Start, Slave Addr
	ldi	datrs,$00	;.:C0,D/C =0
	rcall	WrBt2C
	ldi	datrs,FuncSet|(0<<H)	;H=0
	rcall	WrBt2C
	ldi	datrs,setY	; H=0:
	add	datrs,addrY	; DDRAM (Y=0..7)
	rcall	WrBt2C
	rcall	TWStop
	ret
;=======
SetAddr:andi	addrY,$0f		;310
	rcall	TWWrAddr	;Start, Slave Addr

	ldi	datrs,$00	;.:C0,D/C =0
	rcall	WrBt2C
	ldi	datrs,FuncSet|(0<<H)	
	rcall	WrBt2C
	ldi	datrs,setY	; H=0:
	add	datrs,addrY	; DDRAM (Y=0..7)
	rcall	WrBt2C
	ldi	datrs,setX|3	; X		
	rcall	WrBt2C
	rcall	TWStop
	ret
;=======
Invert:	rcall	TWWrAddr		;311
	ldi	datrs,$00	;.:C0,D/C =0
	rcall	WrBt2C
	ldi	datrs,FuncSet|(0<<H)	;H=0
	rcall	WrBt2C
	ldi	datrs,ScrMode|(1<<D)|(1<<E)	
	rcall	WrBt2C
	rcall	TWStop
	ret
;===========
UnInvert:					;312
	rcall	TWWrAddr	;Start, Slave Addr
	ldi	datrs,$00	;.:C0,D/C =0
	rcall	WrBt2C
	ldi	datrs,FuncSet|(0<<H)	;H=0
	rcall	WrBt2C
	ldi	datrs,ScrMode|(1<<D)|(0<<E)	
	rcall	WrBt2C
	rcall	TWStop
	ret
;=========
ShowLine:				;313
	ldi	cnt1,0
Line1:	wdr
	mov	addrY,cnt1		;314
	lsr	addrY
	lsr	addrY
	lsr	addrY
	ldi	tmp,$40
	add	addrY,tmp
	rcall	SetYAddr
	mov	tmp,cnt1		;315
	andi	tmp,7
	ldi	datrs,1
Line2:	tst	tmp		;316
	breq	Line3
	lsl	datrs
	dec	tmp
	rjmp	Line2
Line3:	mov	addrWr,datrs	;317
	rcall	TWWrAddr
	ldi	datrs,$40
	rcall	WrBt2C
	mov	datrs,addrWr
	rcall	WrBt2c
	rcall	TWStop
	inc	cnt1
	cpi	cnt1,65		;318
	brlo	Line1
	ret
;=^=3=^=

;=== 4===
; 09:
e0:	.db $7c,$8a,$92,$a2,$7c,0
e1:	.db $00,$42,$fe,$02,$00,0
e2:	.db $42,$86,$8a,$92,$62,0
e3:	.db $84,$92,$b2,$d2,$8c,0	
e4:	.db $18,$28,$48,$fe,$08,0	
e5:	.db $e4,$a2,$a2,$a2,$9c,0	
e6:	.db $6c,$92,$92,$92,$0c,0	
e7:	.db $80,$8e,$90,$a0,$c0,0	
e8:	.db $6c,$92,$92,$92,$6c,0
e9:	.db $64,$92,$92,$92,$7c,0

;  
;:
eA:	.db $7e,$88,$88,$88,$fe,0
eB:	.db $fe,$92,$92,$92,$6c,0	
eC:	.db $7c,$82,$82,$82,$44,0
eD:	.db $fe,$82,$82,$44,$38,0
eE:	.db $fe,$92,$92,$92,$82,0
eF:	.db $fe,$90,$90,$90,$80,0
eG:	.db $7c,$82,$92,$92,$5c,0
eH:	.db $fe,$10,$10,$10,$fe,0
eI:	.db $00,$82,$fe,$82,$00,0
eJ:	.db $04,$02,$82,$fc,$80,0
eK:	.db $fe,$10,$28,$44,$82,0
eL:	.db $fe,$02,$02,$02,$02,0
eM:	.db $fe,$40,$30,$40,$fe,0
eN:	.db $fe,$20,$10,$08,$fe,0
eO:	.db $7c,$82,$82,$82,$7c,0
eP:	.db $fe,$90,$90,$90,$60,0
eQ:	.db $7c,$82,$8a,$86,$7c,0
eR:	.db $fe,$90,$98,$94,$62,0
eS:	.db $62,$92,$92,$92,$8c,0
eT:	.db $80,$80,$fe,$80,$80,0
eU:	.db $fd,$02,$02,$02,$fd,0
eV:	.db $f8,$04,$02,$04,$f8,0
eW:	.db $fd,$02,$fd,$02,$fd,0
eX:	.db $c6,$28,$10,$28,$c6,0
eY:	.db $e0,$10,$0e,$10,$e0,0
eZ:	.db $86,$8a,$92,$a2,$c2,0

;:
rA:	.db $7e,$88,$88,$88,$fe,0	;
rB:	.db $fe,$92,$92,$92,$cc,0	;
rV:	.db $fe,$92,$92,$92,$6c,0	;
rG:	.db $fe,$80,$80,$80,$c0,0	;
rD:	.db $06,$7c,$84,$fc,$06,0	;
rE:	.db $fe,$92,$92,$92,$82,0	;
rJ:	.db $ee,$10,$fe,$10,$ee,0	;
rZ:	.db $82,$92,$92,$92,$6c,0	;
rI:	.db $fe,$08,$10,$20,$fe,0	;
rIY:	.db $7e,$84,$48,$90,$7e,0	;
rK:	.db $fe,$10,$28,$44,$82,0	;
rL:	.db $04,$82,$fc,$80,$fe,0	;
rM:	.db $fe,$40,$30,$40,$fe,0	;
rH:	.db $fe,$10,$10,$10,$fe,0	;
rO:	.db $7c,$82,$82,$82,$7c,0	;0
rP:	.db $fe,$80,$80,$80,$fe,0	;
rR:	.db $fe,$90,$90,$90,$60,0	;
rS:	.db $7c,$82,$82,$82,$44,0	;
rT:	.db $80,$80,$fe,$80,$80,0	;
rY:	.db $e0,$10,$0e,$10,$e0,0	;
rF:	.db $38,$44,$fe,$44,$38,0	;
rX:	.db $c6,$28,$10,$28,$c6,0	;
rTs:	.db $fe,$02,$02,$02,$fe,$03	;
rCh:	.db $e0,$10,$10,$10,$fe,0	;
rSh:	.db $fe,$02,$fe,$02,$fe,0	;
rSc:	.db $fe,$02,$fe,$02,$fe,$03	;
rTv:	.db $80,$fe,$12,$12,$0c,0	;
rIt:	.db $fe,$12,$0c,$00,$fe,0	;
rMy:	.db $fe,$12,$12,$12,$0c,0	;
rEr:	.db $44,$82,$92,$92,$7c,0	;
rU:	.db $fe,$10,$7c,$82,$7c,0	;
ryA:	.db $62,$94,$98,$92,$fe,0	;
Space: .db 0,0,0,0,0,0	;
;=^= 4=^=

