;;;;;check_the_clock_ds1307.asm version 1.00 26.09.2005 by Siriasis

.include	"m128def.inc"

.def	temp1=		r16
.def	temp2=		r17
.def	temp3=		r18
.def	temp4=          r19



.org 0x00
	rjmp	start

;there we organize the interrupt table
.org	0x0002	jmp	start;     ext_int_0- external interrupt request 0
.org	0x0004	jmp	start;	   ext_int_1- external interrupt request 1
.org	0x0006	jmp	start;	   ext_int_2- external interrupt request 2
.org	0x0008	jmp	start;	   ext_int_3- external interrupt request 3 
.org	0x000a	jmp	start;     ext_int_4- external interrupt request 4
.org	0x000c	jmp	start;     ext_int_5- external interrupt request 5  
.org	0x000e	jmp	start;     ext_int_6- external interrupt request 6
.org	0x0010	jmp	start;     ext_int_7- external interrupt request 7
.org	0x0012	jmp	start;	   tim2_comp-  timer 2 compare match	
.org	0x0014	jmp	start;	   tim2_ovf -  timer 2 overflow		
.org	0x0016	jmp	start;     tim1_capt-  timer 1 capture event 
.org	0x0018	jmp	start;     tim1_compa- timer 1 compare match a
.org	0x001a	jmp	start;	   tim1_compb- timer 1 compare match b 	
.org	0x001c	jmp	start;	   tim1_ovf-   timer 1  overflow		
.org	0x001e	jmp	start;	   tim0_comp-  timer 0 compare match		
.org	0x0020	jmp	start;	   tim0_ovf -  timer counter 0 overflow
.org	0x0022	jmp	start; 	   spi_stc  -  spi serial transfer complete 	    
.org	0x0024	jmp	start;	   usart0_rxc- usart reception complete	
.org	0x0026	jmp	start;     usart0_udre-usart0 data register is empty		
.org	0x0028	jmp	start;     usart0_tx  -usart0 transmission complete
.org	0x002a	jmp	start;     adc        -adc conversion complete 
.org	0x002c	jmp	start;     ee_ready   -eeprom ready interrupt
.org	0x002e	jmp	start;	   analog_comp- the interrupt from the analog comparator match	
.org	0x0030	jmp	start;	   timer1_compC- timercounter compare match c 	
.org	0x0032	jmp	start;     timer3_capt - timer_counter 3 capture event 
.org	0x0034	jmp	start;     timer3_compa- timer counter 3 compare match a
.org	0x0036	jmp	start;     timer3_compb- timer counter 3 compare match b 
.org	0x0038	jmp	start;     timer3_compc- timer counter 3 compare match c		
.org	0x003a	jmp	start;     timer3_ovf -  timer counter 3 overflow
.org	0x003c	jmp	start; 	   usart_1_rxc-  usart1 recieve rxc complete		
.org	0x003e	jmp	start;     usart1_udre-  usart1 data register empty
.org	0x0040	jmp	start;	   usart_1_txc-  usart1 transmit  complete	
.org	0x0042	jmp	start;     twi        - twi interrupt	 
.org	0x0044	jmp	start;     spm_ready  - store programm memory ready

;;;;;;;;;;;;;;;;;;;;;;;;constants places in flash memory;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
.org  0x100
	
;;;constants in the flash memory 
	.equ	scl_port=	porte;;;there we change the name of port if the scl line is situated on another port
	.equ	sda_port=	portd;;;there we change the name of port if the sda line is situated on another port
	.equ	scl_direction_port= ddre;; there we change the name of direction port 
	.equ	sda_direction_port= ddrd;; there we change the name of direction port
	.equ	scl_input_port	= pine
	.equ	sda_input_port	= pind

;;;;the constants which define the place of signal lines with 
	.equ	scl_line	=5;;we change the nomber of bit if the scl line is on another pin of port  
	.equ	sda_line	=7;;we change the nomber of bit if the scl line is on another pin of port 

;;;;the constants in flash memory
	.equ	usart_speed	=95
	.equ	clock_adress_process_writing	= 0b11010000;;;0--show the operation of writing to the ds1307
	.equ	clock_adress_process_reading	= 0b11010001;;;1--show the reading operation with ds1307 
	.equ	word_adress			= $00	
;;;;;the initial length of the buffer recieved from the pc 
	.equ	length_of_buffer_recieve_from_pc= 8
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
start:
initialiastion_full:
	;;initialisation of satck 
	ldi	temp1, low(ramend)
	ldi	temp2, high(ramend)
	out	spl, temp1
	out	sph, temp2
initialisation_of_usart_1:
	;;initialise the usart1
	ldi	temp1, low(usart_speed);;initialise the usart speed
	ldi	temp2, high(usart_speed); initialise the usart_speed
	sts	ubrr1h, temp2
	sts	ubrr1l, temp1
	ldi	temp1, (1<<rxen1)|(1<<txen1);; enable the reciever and transmitter 
	sts	ucsr1b, temp1
	ldi	temp1, (1<<usbs1)|(3<<ucsz10);;; 8bits and 2 stop bits
	sts	ucsr1c, temp1
	;;;;initialise the lines of the ds 1307 clock
	ldi	temp1, (1<<scl_line)
	out	scl_direction_port, temp1
	ldi	temp2, (1<<sda_line)
	out	sda_direction_port, temp2

	ldi	zl, low(buffer_recieve_from_pc_installed_time_to_ds1307)
	ldi	zh, high(buffer_recieve_from_pc_installed_time_to_ds1307)  

;;;========================================================================================
;;;;;;;;;begin transaction of data to be latched in the ds1307 from pc/ Full fill the buffer 
recieve_byte_to_full_fill_the_buffer:	
	rcall	usart_1_recieve
	;;;make simple check of input data from the pc to mcu
	lds	temp1, usart_buffer_recieve
	sts	usart_buffer_transmit, temp1
	rcall	usart_1_transmit

	lds	temp1, usart_buffer_recieve
	st	z+, temp1
		
	cpi	zl, length_of_buffer_recieve_from_pc
	breq	end_of_full_fill_the_buffer_recieved_from_pc
	rjmp	recieve_byte_to_full_fill_the_buffer	

end_of_full_fill_the_buffer_recieved_from_pc:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;========================================================================================

;;;========================================================================================
;;;;;there the routines of transmission the data-time to ds1307 is accomplished;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;a2;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	

frame_of_data_to_the_ds1307:
	;set to high logic level the lines sda and scl
	sbi	sda_port, sda_line
	sbi	scl_port, scl_line 	

	rcall	start_condition_i2c
	ldi	temp1, clock_adress_process_writing;;at first we send to the slave the adress 
	;;;of the device ds1307  
	rcall	out_byte_i2c_transmit
	rcall	get_acknowledge_from_slave
	ldi	temp1, word_adress+7;;;;;;;!!!!!!!!!!!DO NOT UNDERSTAND tis is fucking mistake that i dont understand
	rcall	out_byte_i2c_transmit
	rcall	get_acknowledge_from_slave
	;;set the beginning adress of the buffer which will be transported to  ds1307
	ldi	zl, low(buffer_recieve_from_pc_installed_time_to_ds1307)
	ldi	zh, high(buffer_recieve_from_pc_installed_time_to_ds1307)

;;;;;;;;;;;;;;;;;;;;;;;;;;a3;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

next_byte_transmit_to_ds1307:
	;;;the main loop of transmission the necessary data of time to the ds1307
	ld	temp1, z+
	rcall	out_byte_i2c_transmit
	rcall	get_acknowledge_from_slave	 
	cpi	zl, length_of_buffer_recieve_from_pc;;;check does the buffer goto the end 		
	breq	end_of_transmission_necessary_data_to_ds1307
	rjmp	next_byte_transmit_to_ds1307

end_of_transmission_necessary_data_to_ds1307:
	; then according to the	protocol of i2c busort twi bus we form the stop condition action
	;;after the 8-th byte was removed to the slave ds1307
	rcall	get_acknowledge_from_slave	
	rcall	stop_condition_i2c
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;========================================================================================
	;make little delay about 1 seconds to read new value of time after the writing process
	
	rcall	delay_from_timer_0;;;;;the delay of 1 seconds
				
	;;;========================================================================================
;;;;;there the routines of reception the data-time from ds1307;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;there we must hold the adress of the register pointer to ds 1307/ But this i not writtenin the 
;;;;documentation
data_to_the_ds1307_before_reception:
	;set to high logic level the lines sda and scl
	sbi	sda_port, sda_line
	sbi	scl_port, scl_line 	

	rcall	start_condition_i2c
	ldi	temp1, clock_adress_process_writing;;at first we send to the slave the adress 
	;;;of the device ds1307  
	rcall	out_byte_i2c_transmit
	rcall	get_acknowledge_from_slave
	ldi	temp1, word_adress;;;;;;;!!!!!!!!!!!DO NOT UNDERSTAND 
	rcall	out_byte_i2c_transmit
	rcall	get_acknowledge_from_slave     
	rcall	stop_condition_i2c
frame_of_data_to_the_ds1307_reception_process:
	rcall	start_condition_i2c
	ldi	temp1, clock_adress_process_reading;;at first we send to the slave the adress
	;;;of the device ds1307/ But now this adress wii distinguish from the past because 
	;;;this is the process of reception the data from the ds1307
	rcall	out_byte_i2c_transmit	
	rcall	get_acknowledge_from_slave
	
	ldi	zl, low(buffer_transmit_from_mcu_to_pc)
	ldi	zh, high(buffer_transmit_from_mcu_to_pc)
next_byte_reception_from_ds1307: 		
	rcall	byte_i2c_recieve
	;;;the recieved databyte is saved in the temp1 register  
	st	z+, temp1	
	;;;;check does the buffer reach the end of its length
	cpi	zl, length_of_buffer_recieve_from_pc
	breq	the_data_transmission_finished

	rcall	acknowledge_with_the_side_of_master
	;;rcall	delay_for_scl_pulse  
	rjmp	next_byte_reception_from_ds1307 

the_data_transmission_finished:	
	;;;there we for not acknowledge signal on the sda line and latch it bu scl pulse on 
	;;;the scl line
	rcall	not_acknowledge_operation
	;rcall	delay_for_scl_pulse
	rcall	stop_condition_i2c
	;rcall	delay_for_scl_pulse
;;;the end of routines of reception the data from the ds1307 microcircuit
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;========================================================================================		


	;;load the beginner adress  of the buffer to be transmitted to the pc
	ldi	zl, low(buffer_transmit_from_mcu_to_pc);;;not to get ff/ I dont know why/ First working variant
	ldi	zh, high(buffer_transmit_from_mcu_to_pc)
byte_from_buffer_to_pc:	
	ld	temp2, z+
	sts	usart_buffer_transmit, temp2 	
	rcall	usart_1_transmit
	cpi	zl, $07;;;;;we dont need eight byte in this fucking from the ass making algorithm/ But works
	breq	end_of_transmission_the_data_from_the_time_buffer_to_pc
	rjmp	byte_from_buffer_to_pc 	
end_of_transmission_the_data_from_the_time_buffer_to_pc:
	;;;;;at the end of transmission we return to the beginning but in this case. In future we will
	;;;;;will come to the next stage of the check 	
	
	
	;get_request_and_acknowledge_to_continue_the_programm:
;;;;;;get request from pc and transmit acknowledge to be ready to begin the check
second_request:

	rcall	usart_1_recieve
	lds	temp1, usart_buffer_recieve
	cpi	temp1, $66
	breq	data_to_the_ds1307_before_reception
	rjmp	second_request
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;     ;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;     ;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;     ;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;     ;;;;;;;;;;;;;
             ;;;main_i2c_operational stages to work with the ds1307 clock

;;;========================================================================================
;;;;the producing of start condition by the master in such situation
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
start_condition_i2c:
	sbi	scl_port, scl_line
	sbi	sda_port, sda_line
	;;;make the change in the state of data line
		;;change the direction of sda_line
	cbi	sda_port, sda_line;; come to low level

	rcall	delay_for_scl_pulse;;;we must hold the scl line on high level during the Thdsta(figure indatasheet)
	;;;thd- 4.7mkS  
	ret
;;;end ofd the programm of start condition;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;========================================================================================


;;;========================================================================================
;;;transmission of byte to the ds1307 universal routine. Main local variable is counter_of_log_shifts
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
out_byte_i2c_transmit:
	;;;load the zero value to the counter of shifts
	ldi	temp2, $00
	sts	counter_of_log_shifts, temp2

	;;;make scl low to make simply produce the pulse 
	cbi	scl_port, scl_line 
	;;;the to be output by the mcu is in the temp1 register/ Before this programm we must 
	;;;put the necessary data in the temp1 register
another_bit_to_be_transferred:
	lsl	temp1
	brcs	transfer_logic_one_to_ds1307
transfer_logic_zero_to_ds1307:

	cbi	sda_port, sda_line;;the main command of setting the data bit on the sda line  
	
	cbi	scl_port, scl_line
	rcall	delay_for_scl_pulse;;;delay about 7mkS	
	sbi	scl_port, scl_line
	rcall	delay_for_scl_pulse;;;delay about 7mkS	  	
	cbi	scl_port, scl_line
	;rcall	delay_for_scl_pulse
	;;;increase the value of the counter
	lds	temp2, counter_of_log_shifts
	inc	temp2
	sts	counter_of_log_shifts, temp2
	cpi	temp2, $08;;;check: the 0 bit was bweing shifted or no 
	breq	out_of_routine;;; out from this sub_routine	 
	rjmp	another_bit_to_be_transferred;;; another bitto prepare to be transferred to ds1307
transfer_logic_one_to_ds1307:
	;;;the programm of transfer the logic one to the ds1307
	sbi	sda_port, sda_line
	;;; make pulse on scl line
	cbi	scl_port, scl_line
	rcall	delay_for_scl_pulse;;litlle delay about 7mkS
	sbi	scl_port, scl_line
	rcall	delay_for_scl_pulse;;little dealy about 7 mkS	  	
	cbi	scl_port, scl_line
	rcall	delay_for_scl_pulse
	;;;increase the value of counter 
	lds	temp2, counter_of_log_shifts
	inc	temp2
	sts	counter_of_log_shifts, temp2
	cpi	temp2, 8
	breq	out_of_routine	
	rjmp	another_bit_to_be_transferred	
out_of_routine:
	;;;set the sda line to low level for waiting the acknowledge from the ds1307
	ret	 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;========================================================================================

;;;========================================================================================
;;;the routine of reception one byte from the clock;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;we recieve the byte from the ds 1307 and the data is saved in the temp1 register
;;;the local variables are the counter_of_log_shifts_reception which is set to zero value at the 
;;;beginnig of the programm

byte_i2c_recieve:
	;first value to the temp1
	ldi	temp1, $00
	
	ldi	temp2, $00
	sts	counter_of_log_shifts_reception, temp2
	;;;first bit reception
	;;;change the direction of sda line

;;;;;;;;
;;;;;;;;;;;;I had problem with this fucking direction port
	cbi	sda_direction_port, sda_line;;; 
;;;;;;;;;this is the main pecularity of such fucking interface or bus. I dont know 
;;;;;;;;;;;

	;;;transmitted by the slave clock ds1307 
next_bit_to_recieve:
	;;make the latch by scl line the data bit which is on the sda line
	cbi	scl_port, scl_line
	rcall	delay_for_scl_pulse;;little delay about 7mkS
	sbi	scl_port, scl_line
	rcall	delay_for_scl_pulse;;little_delay bout 7mkS 
	cbi	scl_port, scl_line	
	;;;after the latch on the scl line we make the analisis of the sda line
	in	temp2, sda_input_port
	sbrs    temp2, sda_line
	rjmp	recieve_zero_from_slave
recieve_one_from_slave:
	sec;     set the carry flag and set the value of flag to the temp1
	rol	temp1
	lds	temp2, counter_of_log_shifts_reception
	inc	temp2
	sts	counter_of_log_shifts_reception, temp2
	cpi	temp2, 8
	breq	recieved_byte_is_ready_and_set_in_temp1
	rjmp	next_bit_to_recieve
recieve_zero_from_slave:
	;;;we recieve here the zero from the ds1307 clock	
	clc;;clear the carry flag and set the value of flag to the temp1
	rol	temp1;;this the method to load the register with the bits which are recieved from 
	;;;sda line
	lds	temp2, counter_of_log_shifts_reception
	inc	temp2
	sts	counter_of_log_shifts_reception, temp2
	cpi	temp2, 8
	breq	recieved_byte_is_ready_and_set_in_temp1
	rjmp	next_bit_to_recieve
		
recieved_byte_is_ready_and_set_in_temp1:
	;;;the recieved byte is in the temp1 register and ready  to be loaded	in the 
	;buffer of usart1 to transfer the sequent data of time buffer_transmit_time_to_pc 
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;========================================================================================
;;;;
;;;;	
;;;;
;;;========================================================================================
;;;;;;;;;;;;the program of analisis the acknowledge from the side of the master(mcu)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
get_acknowledge_from_slave:
	cbi	sda_direction_port, sda_line
	;sbi	sda_input_port, sda_line 
	;;;make the pin of sda line on the input
	;;;no we will make the pulse influence on scl line to analise the state of the 
	;;;sda line
repeat_ones_more_please:	
	cbi	scl_port, scl_line
	rcall	delay_for_scl_pulse;;; we must hold the low level of scl pulse fo 4.7 mkS minimum
	sbi	scl_port, scl_line
	rcall	delay_for_scl_pulse
	cbi	scl_port, scl_line
	;rcall	delay_for_scl_pulse
;repeat_ones_more_please_1: 
	in	temp2, sda_input_port	 
	;;;there we begin to analise the state on the pin of sda line 
	sbrc	temp2, sda_line
	rjmp	repeat_ones_more_please 
out_of_acknowledge:
	;;;;change the direction of the pin sda after reception of acknowledge
	sbi	sda_direction_port, sda_line
	sbi	sda_port, sda_line
	ret		  
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;========================================================================================
;;;;
;;;;
;;;;
;;;========================================================================================
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;the programm of stop_condion made by the master after the transmission;;;;;;;;;;;;;;
stop_condition_i2c:
	sbi	scl_port, scl_line
	cbi	sda_port, sda_line
	rcall	delay_for_scl_pulse
	sbi	sda_port, sda_line
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;========================================================================================
;;;;
;;;;
;;;;
;;;========================================================================================
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;a "no acknowledge" operation to show the end of reception from the 
not_acknowledge_operation:
	sbi	sda_port, sda_line
	cbi	scl_port, scl_line
	sbi	scl_port, scl_line
	nop;;;little  delay
	nop;;;little  delay
	nop;;;little  delay
	cbi	scl_port, scl_line
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;========================================================================================	


;;;========================================================================================
;;;;;;the acknowledge with the side of master after recieving one byte from the ds1307;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
acknowledge_with_the_side_of_master:

	sbi	sda_direction_port, sda_line;;;we shouldn not forget about the direction of the
	;port but now this is my rude mistake and all fucking thins are coming from this moments
	
	cbi	sda_port, sda_line;;we must put to low level the sda line and
	cbi	scl_port, scl_line;;;latch with the side of master-controller
	rcall	delay_for_scl_pulse;;this is the clock cycle for acknowledge bit with the side of master  bits 
	sbi	scl_port, scl_line
	rcall	delay_for_scl_pulse
	cbi	scl_port, scl_line
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;;
;;;;
;;;;
;;;========================================================================================	
;;;usart_routines of reception and transmission
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
usart_1_recieve:
	lds	temp1, ucsr1a
	sbrs	temp1, rxc1
	rjmp	usart_1_recieve
	lds	temp1, udr1
	sts	usart_buffer_recieve, temp1
	ret

;;;usart_transmit routine;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

usart_1_transmit:
	lds	temp1, ucsr1a
	sbrs	temp1, udre1
	rjmp	usart_1_transmit
	lds	temp1, usart_buffer_transmit
	sts	udr1, temp1
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;========================================================================================


;;;========================================================================================
;;;;;;the programm of delay to form the scl pulse the low part and the high part;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
delay_for_scl_pulse:
	ldi	temp4, $00
increase_the_counter:	
	inc	temp4
	cpi	temp4, 100
	breq	out_from_the_programm
	rjmp	increase_the_counter	
out_from_the_programm:
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;========================================================================================


;;;========================================================================================
;;;;;;;timer 0 delay routine;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
delay_from_timer_0:
	ldi	temp1, $00
	sts	counter_additive_to_get_sec, temp1
initialise_the_timer:
	ldi	temp3, $07;$07;;7-shows the prescaler fclk/1024
	;;;;the timer will switch 1 time per 69mkS
	out	tccr0, temp3;;simple initialisation of timer
	ldi	temp3, $01;;;simple initialisation of timer 
	out	tcnt0, temp3
	ldi	temp3, 00;;;simple initialisation of timer 
	out	tifr, temp3
read_value_wait_overflow:
	in	temp1, tifr 	
	sbrs	temp1, tov0;;;check does the timer reach its border and come to overflow 
	rjmp	read_value_wait_overflow
out_of_delay:
	lds	temp2, counter_additive_to_get_sec
	inc	temp2
	sts	counter_additive_to_get_sec, temp2
	cpi	temp2, 60;;;;this value we need to get the delay time about 1sec 
	breq	end_of_delay
	;;;clear the tov0 flag
	ldi	temp3, $01;;;we should not forget that the tov0 is cleared alternatively by
	;;;writing the logical one to the flag
	out	tifr, temp3 
	rjmp	read_value_wait_overflow 
end_of_delay:
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;========================================================================================
		

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;segment in sram;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.dseg
.org	0x100

	usart_buffer_recieve:	.byte	1
	usart_buffer_transmit:	.byte	1
	counter_of_log_shifts:	.byte	1;;;initialise the place to the counter of logicall shifts
	;;;we use this variable at the programm of out_byte_i2c
	counter_of_log_shifts_reception:	.byte	1
	;;;;;for timer 0 additive counter
	counter_additive_to_get_sec:	.byte	1
 
.org	0x200
	buffer_recieve_from_pc_installed_time_to_ds1307:	.byte	8
.org    0x400
	buffer_transmit_from_mcu_to_pc:				.byte	8			
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;========================================================================================
;;;========================================================================================
;;;;;;;the end;;;;

	