;  
;==================================
.include "D:\Program Files\Atmel\AVR Tools\AvrAssembler2\Appnotes\tn2313def.inc"
.def	tmp 	= r16
.equ	door 	= PORTD2
.equ	code 	= PORTD3
.equ	open	= PORTD4

.equ	lock	= PORTB2
.equ	alarm 	= PORTB1
.equ	hl 	= PORTB0

.cseg
.org 0
	rjmp	RESET		;Reset Handler
	nop	;rjmp INT0      ;External Interrupt0
	nop	;rjmp INT1      ;External Interrupt1
	nop	;rjmp ICP1      ;Input capture interrupt 1
	nop	;rjmp OC1A      ;Timer/Counter1 Compare Match A     
	nop	;rjmp OVF1      ;Overflow1 Interrupt 
	nop	;rjmp OVF0      ;Overflow0 Interrupt
	nop	;rjmp URXC0     ;USART0 RX Complete Interrupt
	nop	;rjmp UDRE0     ;USART0 Data Register Empty Interrupt
	nop	;rjmp UTXC0     ;USART0 TX Complete Interrupt 
	nop	;rjmp ACI       ;Analog Comparator Interrupt 
	nop	;rjmp PCINT     ;Pin Change Interrupt
	nop	;rjmp OC1B      ;Timer/Counter1 Compare Match B
	nop	;rjmp OC0A      ;Timer/Counter0 Compare Match A     
	nop	;rjmp OC0B      ;Timer/Counter0 Compare Match B     
	nop	;rjmp USI_START ;USI start interrupt
	nop	;rjmp USI_OVF   ;USI overflow interrupt
	nop	;rjmp ERDY      ;EEPROM write complete
	nop	;rjmp WDT       ;Watchdog Timer Interrupt

RESET:	ldi	tmp,low(RAMEND)	; 
	out	SPL,tmp		;  
	clr	tmp			;  tmp (= 0)
	out	DDRD,tmp		;  D - 
	out	PORTB,tmp		;    B
					;  
	ser	tmp			; tmp (= $ff)
	out	PORTD,tmp		;   
					; D  
	out	DDRB,tmp		;  B - 
	out	PIND,tmp		;     AVR Studio. 
;    D   . 
;    , ;     
;   PIND   New IO View. 
; PIND  ,    
;   D , 
;     : 
;"", " "  " "
	ldi	tmp,(1<<WDCE)|(1<<WDE)
	out	WDTCR,tmp			; 
	ldi	tmp,(1<<WDE)|(1<<WDP2)|(1<<WDP1)|(1<<WDP0)
	out	WDTCR,tmp		;:   
					; (wdr)   2 
					;   
					;RESET
	clt				; T-  
main:	wdr				;  
	sbis	PIND,code		;  ,
					;   code (PD3)
					; 
	rcall	OpenLock		;  OpenLock
	sbis	PIND,open		;  ,
					;   open (PD4)
					; 
	rcall	OpenLock		;  OpenLock
	sbis	PIND,door		;  ,
					;   door (PD2)
					; 
	rcall	DoorIsOpen		;  DoorIsOpen
	clt				; T-  
	rjmp	main			;   c  main:

;  :
;===============================
OpenLock:
	sbi	PORTB,lock		;  
					;  lock  B
	rcall	d500ms		;  
	rcall	d500ms		;  500  
	rcall	d500ms
	rcall	d500ms
	cbi	PORTB,lock		;  
					;  lock (PB2)
	ldi	tmp,10		;  tmp  10
more:	rcall	d500ms		; 
					;  500 
	dec	tmp			;  tmp  1
	brne	more			;  Z  
					;   1 ( tmp 
					;  ),
					;   more:
	set				;  T   
	ret				;  

;    :
;=============================================
DoorIsOpen:
	brts	NoClose		;     
					;,  
					;  NoClose:
	sbi	PORTB,hl		;  
					;  hl (PB0)
	ldi	XL,low(500)		;   
	ldi	XH,high(500)		;XH:XL  500
					;( XL  
					;  500,
					; XH -    500)
NewPls:	wdr				;  
	sbi	PORTB,alarm		;  
					;  alarm (PB1)
	rcall	d05ms		;  
					; 0.5 
	cbi	PORTB,alarm		;  
					;  alarm (PB1)
	rcall	d05ms		; 
					;  0.5 
	sbiw	XL,1			;  
					; ,
					;   XH:XL
	brne	NewPls		;  Z    
					; ( XH:XL
					;  ), 
					;  NewPls:
	rcall	d500ms		;  
					; 0.5 
	rjmp	DoorIsOpen		;   DoorIsOpen
NoClose:
	sbis	PIND,door		;  ,
					;   door (PD2)
					; 
	rjmp	NoClose		;   NoClose
	ret				;  

;   0.5 :
;==============================
d05ms:	wdr			;  
	ldi	YL,low(497)		;  YH:YL  497
	ldi	YH,high(497)
d05_1:	sbiw	YL,1			;   YH:YL 
	brne	d05_1		;  Z<>0 (
					;  
					;  ), 
					;  d05_1:
	ret				;  

;   500 :
;==============================
d500ms:	ldi	XL,low(1000)	;  XH:XL
	ldi	XH,high(1000)		; 1000
d500_1:	rcall	d05ms		;  
					; 0.5 
	sbiw	XL,1			; 
					;  XH:XL
	brne	d500_1		;    ,
					;   d500_1:
	ret				;  
