;     
;=============================================
.include "D:\Program Files\Atmel\AVR Tools\AvrAssembler2\Appnotes\tn2313def.inc"
.def	tmp 		= r16
.def	OpnEnbl 	= r17
.equ	door 		= PORTD2
.equ	code 		= PORTD3
.equ	open 		= PORTD4
.equ	lock 		= PORTB2
.equ	alarm 		= PORTB1
.equ	hl 		= PORTB0
.equ	t05mc		= 249	; TCCR0B<-2 (Fck/8)
.equ	t500mc		= 7812	; TCCR1B<-4 (Fck/256)
.equ	t7c		= 27344	; TCCR1B<-5 (Fck/1024)
.equ	t5c		= 19531	; TCCR1B<-5 (Fck/1024)
.cseg
.org 0
	rjmp	RESET		;Reset Handler
	nop	;rjmp INT0      ;External Interrupt0
	nop	;rjmp INT1      ;External Interrupt1
	nop	;rjmp ICP1      ;Input capture interrupt 1
	rjmp	OC1A     	 ;Timer/Counter1 Compare Match A     
	rjmp	OVF1      	;Overflow1 Interrupt 
	rjmp	OVF0      	;Overflow0 Interrupt
	nop	;rjmp URXC0     ;USART0 RX Complete Interrupt
	nop	;rjmp UDRE0     ;USART0 Data Register Empty Interrupt
	nop	;rjmp UTXC0     ;USART0 TX Complete Interrupt 
	nop	;rjmp ACI       ;Analog Comparator Interrupt 
	nop	;rjmp PCINT     ;Pin Change Interrupt
	nop	;rjmp OC1B      ;Timer/Counter1 Compare Match B
	nop	;rjmp OC0A      ;Timer/Counter0 Compare Match A     
	nop	;rjmp OC0B      ;Timer/Counter0 Compare Match B     
	nop	;rjmp USI_START ;USI start interrupt
	nop	;rjmp USI_OVF   ;USI overflow interrupt
	nop	;rjmp ERDY      ;EEPROM write complete
	nop	;rjmp WDT       ;Watchdog Timer Interrupt

OC1A:
	cbi	PORTB,lock	;     lock (PB2)
	reti

OVF1:
	clr	OpnEnbl			; 
	cbi	PORTB,alarm		;  
					;  alarm (PB1)
	ldi	tmp,high($10000 - t500mc)	;   ,
					; 500 
	out	TCNT1H,tmp
	ldi	tmp,low($10000 - t500mc)
	out	TCNT1L,tmp
	in	tmp,TIMSK
	sbrc	tmp,TOIE0
	rjmp	cTOIE0
	sbrs	tmp,TOIE0
	rjmp	sTOIE0
cTOIE0:
	cbr	tmp,1<<TOIE0		;   0
	rjmp	go_ret
sTOIE0:
	sbr	tmp,1<<TOIE0		;   0
go_ret:
	out	TIMSK,tmp 
	reti

OVF0:
	ldi	tmp,$100 - t05mc	;  
					;,  0.5 
	out	TCNT0,tmp
	sbis	PORTB,alarm
	rjmp	sAlarm
	sbic	PORTB,alarm
	rjmp	cAlarm
sAlarm:
	sbi	PORTB,alarm		;  alarm
	rjmp	next
cAlarm:
	cbi	PORTB,alarm		;  alarm
next:	clr	tmp
	reti

RESET:	
	ldi	tmp,(1<<TOIE1) + (1<<OCIE1A) + (1<<TOIE0)
	out	TIMSK,tmp		;  
	sei				;  
	ldi	tmp,low(RAMEND)	;  
	out	SPL,tmp
	clr	tmp			; tmp
	out	DDRD,tmp		;  D - 
	out	PORTB,tmp		; B -  
	ser	tmp			; tmp
	out	PORTD,tmp		; D -  
	out	DDRB,tmp		;  B - 
	out	PIND,tmp		;   
	ldi	tmp,(1<<WDCE)|(1<<WDE)
	out	WDTCR,tmp		;  
	ldi	tmp,(1<<WDE)|(1<<WDP2)|(1<<WDP1)|(1<<WDP0)
	out	WDTCR,tmp		;  wdr    2 
	clt				; T-  

;  :
;===========================
main:	wdr				;  
	sbis	PIND,code		;  ,
					;   code (PD3)  
	rcall	OpenLock		;  OpenLock
	sbis	PIND,open		;  ,    open (PD4)
					; 
	rcall	OpenLock		;  OpenLock
	sbis	PIND,door		;  ,    door (PD2)
					; 
	rcall	DoorIsOpen		;  DoorIsOpen
	clt				; T-  
	rjmp	main			;     main:

;  :
;============================
OpenLock:
	sbi	PORTB,lock		;  
					;  lock  B
	ldi	tmp,high($10000 - t7c)	;  
	out	TCNT1H,tmp		;  
	ldi	tmp,low($10000 - t7c)	; 7 
	out	TCNT1L,tmp
	ldi	tmp,5			;  1  
	out	TCCR1B,tmp		;    1024
	ldi	tmp,high($10000 - t5c)
	out	OCR1AH,tmp		;  
	ldi	tmp,low($10000 - t5c)	; 
	out	OCR1AL,tmp		; 5   
	ldi	OpnEnbl,$ff		;  tmp 
more:	wdr
	tst	OpnEnbl
	brne	more			;   more:
					;  ;
	clr	tmp
	out	TCCR1B,tmp		;  1
	set				;  T   
	ret				;  

;    :
;==========================================
DoorIsOpen:
	brts	NoClose			;      ,
					;   NoClose:
	sbi	PORTB,hl		;     hl (PB0)
	in	tmp,TIMSK
	cbr	tmp,1<<OCIE1A		; 	
	out	TIMSK,tmp		;  
					;  1  
	ldi	tmp,high($10000 - t500mc)
	out	TCNT1H,tmp		;  
					; 500    1
	ldi	tmp,low($10000 - t500mc)
	out	TCNT1L,tmp			
	ldi	tmp,4			;  1  
	out	TCCR1B,tmp		;   256
	ldi	tmp,$100 - t05mc	;  
	out	TCNT0,tmp		; 0.5   0
	ldi	tmp,2			;  0  
	out	TCCR0B,tmp		;   8
	sbi	PORTB,alarm		;  
					;  alarm  B
NonStop:
	wdr
	rjmp	NonStop
NoClose:
	wdr
	sbis	PIND,door		;  ,
					;   door
					;(PD2)  
	rjmp	NoClose			;   NoClose
	ldi	tmp,$100 - 255
	out	TCNT0,tmp
	clr	tmp
	out	TIFR,tmp
	ldi	tmp,5
	out	TCCR0B,tmp
	in	tmp,TIMSK
	sbr	tmp,1<<TOIE0		;  
	out	TIMSK,tmp		; 0

wait:	wdr
	tst	tmp
	brne	wait
	ret				;  
