#include <pic.h>
#include "rs232.h"
#include "Delay.h"

unsigned char state;//  

// 
void Setup (void)
{
 state = 0;//     USART
//  
 TRISA = 0x0;//  
 CMCON=0b00000111; //  
 VRCON=0b00000000; //   

//  
TRISB &= 6;//  ,  RB1, RB2 -    USART
// 
INTCON=0b11000000;  
/*
          bit 7: GIE: Global Interrupt Enable bit                                                            
                 1 = Enables all un-masked interrupts                                                        
                 0 = Disables all interrupts                                                                 
          bit 6: PEIE: Peripheral Interrupt Enable bit                                                       
                 1 = Enables all un-masked peripheral interrupts                                             
                 0 = Disables all peripheral interrupts                                                      
          bit 5: T0IE: TMR0 Overflow Interrupt Enable bit                                                    
                 1 = Enables the TMR0 interrupt                                                              
                 0 = Disables the TMR0 interrupt                                                             
          bit 4: INTE: RB0/INT External Interrupt Enable bit}                                                
                 1 = Enables the RB0/INT external interrupt                                                  
                 0 = Disables the RB0/INT external interrupt                                                 
          bit 3: RBIE: RB Port Change Interrupt Enable bit                                                   
                 1 = Enables the RB port change interrupt                                                    
                 0 = Disables the RB port change interrupt                                                   
          bit 2: T0IF: TMR0 Overflow Interrupt Flag bit                                                      
                 1 = TMR0 register has overflowed (must be cleared in software)                              
                 0 = TMR0 register did not overflow                                                          
          bit 1: INTF: RB0/INT External Interrupt Flag bit                                                   
                 1 = The RB0/INT external interrupt occurred (must be cleared in software)                   
                 0 = The RB0/INT external interrupt did not occur                                            
          bit 0: RBIF: RB Port Change Interrupt Flag bit                                                     
                 1 = When at least one of the RB7:RB4 pins changed state (must be cleared in software)       
                 0 = None of the RB7:RB4 pins have changed state                                             
*/
}


void main(void)
{
// 
Setup ();
// USART
Init_Rs232();
//  RB0      
RB0 = 1;
while (1)
{
 if (RB0 == 1) {RB0 = 0;}
  else {RB0 = 1;}
 DelayMs(100); //
}  
  
}  


interrupt void isr( void)
{
 unsigned char tmp;

 if (RCIF)
 {
//  -    
  RCIF = 0;
  tmp = RCREG;//   
//  WriteChar_Rs232(tmp);//   ,  
  
 if (state == 0)
 {
//   
  switch (tmp)
  {
   case 0:  {state = 1;} break;//  -    
   case 1:  {WriteChar_Rs232(PORTA);}break;//   
									//     
   case 2:  {state = 2;} break;//  -    B
   case 3:  {WriteChar_Rs232(PORTB);}break;//   B
	   
   case 10: {TRISA = 0;} break;//PORTA -  
   case 11: {TRISA = 0b11111;}break;//PORTA -  
   case 20: {TRISB &= 6;}break;//PORTB -  
   case 21: {TRISB |= 255;}break;//PORTB -  
  };
 } 
 else if (state == 1)
 {
//   -     
  PORTA = tmp;
  state = 0;
 }
 else if (state == 2)
 {
//   -     
  PORTB = tmp;
  state = 0;	 
 }
 
  ERR_Rs232 ();//   
 }

}




