#include "Modbus_angle.h"
#include <utility.h>
#include <rs232.h>
#include <cvirte.h>		/* Needed if linking in external compiler; harmless otherwise */
#include <userint.h>

int panel;
unsigned char COMPort;
unsigned char PortIsOpen = 0; 
unsigned char buf[50];  //     -
unsigned char buf_Rx[50]; //      -
unsigned char flag_err_comm=0; //      COM-  


#define OPEN_COM_PORT      { GetCtrlVal(PANEL, PANEL_COMPORT, &temp_com); \
                           if ( PortIsOpen )   CloseCom(COMPort);  \
                           PortIsOpen = 0;	   COMPort = temp_com;      \
                           if  (OpenComConfig (COMPort, "", 9600, 0, 8, 2, 0, 0) < 0) \
                          {MessagePopup ("!", " COM- !");return 0;}  PortIsOpen  = 1;}


static int panelHandle;


/*-----------------------------------------------------------------------------------------------*/



unsigned int CRC_Calc16(unsigned char *b, unsigned char N)
{
unsigned short int crc;				 //  CRC
unsigned char i;
unsigned int j;

crc=0xffff;

for(i=0; i<N; i++)
 {
  crc = crc ^ (unsigned int)b[i];
  for(j=0;j<8;j++)
   {
   if((crc & 0x0001)==1) 
		{	crc>>=1;
			crc ^= 0xa001;
		}
     else crc >>= 1;
   }

 }

crc=(crc<<8)+(crc>>8); //  

return crc;
}


unsigned char Simple_R_T(unsigned char N_TX, unsigned char N_RX,   //  
float Time_Wait)

//N_TX -    ,   CRC/
//N_RX -  ,     (  CRC)
//Time_Wait -   ,      ,   

 { 
	int c1=0; 
	int w=0;
	unsigned int c3;
	unsigned char c2=0, count_0=0, status_p=0, answ=0;

 
 	//  " "
SetCtrlVal(panelHandle, PANEL_LED_COM_PROGRESS, 1);


c3=CRC_Calc16(buf,N_TX);	   // CRC 

	buf[N_TX]=(c3>>8);	    // CRC
	buf[N_TX+1]=c3;
	
    c1=FlushOutQ(COMPort);   //   
if (c1<0) 	{			   //  
			SetCtrlVal(panelHandle, PANEL_LED_COM_PROGRESS, 0);
			SetCtrlVal(panelHandle, PANEL_LED_ERROR, 1); 
			Delay(1);
			SetCtrlVal(panelHandle, PANEL_LED_ERROR, 0);
			return  answ;
			}

			
     c1=FlushInQ(COMPort);  //   
if (c1<0) 	{	   //  
	        SetCtrlVal(panelHandle, PANEL_LED_COM_PROGRESS, 0);
			SetCtrlVal(panelHandle, PANEL_LED_ERROR, 1); 
			Delay(1);
			SetCtrlVal(panelHandle, PANEL_LED_ERROR, 0);
			return  answ;
			}
    
    
    
    if (ComWrt(COMPort,buf,(N_TX+2))!=(N_TX+2))
    {  				   //  
		
	 SetCtrlVal(panelHandle, PANEL_LED_COM_PROGRESS, 0);
	 SetCtrlVal(panelHandle, PANEL_LED_ERROR, 1); 
	 Delay(1);
	 SetCtrlVal(panelHandle, PANEL_LED_ERROR, 0);
	 return  answ;

     }
     
    count_0=0;


do  { w=GetInQLen(COMPort);		   //    
		Delay((((float)Time_Wait)/10));		//	  Time_Wait/10
		count_0++;
		
	if (count_0>10)
	
		{status_p=1;
	  		break;
		}
		
	 }
while (w<(N_RX+2));

SetCtrlVal(panelHandle, PANEL_LED_COM_PROGRESS, 0);   //  " " 


if (status_p==1) {		 //  
	        SetCtrlVal(panelHandle, PANEL_LED_ERROR, 1); 
			Delay(0.4);
			SetCtrlVal(panelHandle, PANEL_LED_ERROR, 0);
			return  answ;
     			  }
	 
	 
	 
   if (ComRd(COMPort,buf_Rx,(N_RX+2))!=(N_RX+2))	   //     Windows
    { 		   //  
		
	  SetCtrlVal(panelHandle, PANEL_LED_ERROR, 1); 
	  Delay(1);
	  SetCtrlVal(panelHandle, PANEL_LED_ERROR, 0);
	  return  answ;
     }
     
c3=(buf_Rx[N_RX]<<8) + buf_Rx[N_RX+1];

if (c3!=CRC_Calc16(buf_Rx,N_RX))
	{  
	        SetCtrlVal(panelHandle, PANEL_LED_ERROR, 1); 
			Delay(1);
			SetCtrlVal(panelHandle, PANEL_LED_ERROR, 0);
			return  answ;
	}

answ=1;     
return answ;
 }					   



unsigned char Prog_Read_Cycle (void)	//     
	
	{
	
	unsigned char c4=0, j=0, i=0;
	unsigned int c5=0;	
	
GetCtrlVal(panelHandle, PANEL_ADDR_BLOCK, &c4);	 //  MODBUS
	buf[0]=c4;
	buf[1]=3;	//   (3- )
	buf[2]=0;   //   ( 0)
	GetCtrlVal(panelHandle, PANEL_NUMBER_REG, &c4);	 //  
	buf[3]=c4;
	buf[4]=0;   //    ( 0)  	
	GetCtrlVal(panelHandle, PANEL_QUANT_REG, &c4);	 //   
	buf[5]=c4;
	
	if (Simple_R_T(6,3+(2*buf[5]),1)!=0)	
		  {
		  if ((buf_Rx[0]==buf[0])&&(buf_Rx[1]==buf[1])&&(buf_Rx[2]==(2*buf[5])))
		  		{  j=0;
		  		
		  		for (i=0; i<buf[5]; i++)
		  			{
		  			c5=(buf_Rx[3+j]<<8)+ buf_Rx[4+j];
		  			
		  			switch (j)
		  				{ case 0: SetCtrlVal(panelHandle, PANEL_REG_1, c5); break;
		  				  case 2: SetCtrlVal(panelHandle, PANEL_REG_2, c5); break;
		  				  case 4: SetCtrlVal(panelHandle, PANEL_REG_3, c5); break;
		  				  case 6: SetCtrlVal(panelHandle, PANEL_REG_4, c5); break;
		  				  case 8: SetCtrlVal(panelHandle, PANEL_REG_5, c5); break;  
		  				}
		  				
		  			  j+=2;	
		  			}
		  		
		  		
		  		}
		  		else
		  		{
		  		 SetCtrlVal(panelHandle, PANEL_LED_ERROR, 1); //:   
				 Delay(0.4);
				 SetCtrlVal(panelHandle, PANEL_LED_ERROR, 0);
		  		}
		  		
		  	  return (1);
		  }
		  else 
		  	return (0);  
		  
	
	
	
	
	}




int main (int argc, char *argv[])
{
	int temp_com;

	if (InitCVIRTE (0, argv, 0) == 0)	/* Needed if linking in external compiler; harmless otherwise */
		return -1;	/* out of memory */
	if ((panelHandle = LoadPanel (0, "Modbus_angle.uir", PANEL)) < 0)
		return -1;
	DisplayPanel (panelHandle);
	OPEN_COM_PORT;
	RunUserInterface ();
	return 0;
}

int CVICALLBACK QUIT_PANEL (int panel, int event, void *callbackData,
		int eventData1, int eventData2)
{
	switch (event)
		{
		case EVENT_GOT_FOCUS:

			break;
		case EVENT_LOST_FOCUS:

			break;
		case EVENT_CLOSE:
		
		QuitUserInterface(0);

			break;
		}
	return 0;
}

int CVICALLBACK DO_COMPORT_OPEN (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	 int temp_com;

	switch (event)								   // COM- 
		{
		case EVENT_COMMIT:
				OPEN_COM_PORT;
			break;
		}
	return 0;
}

int CVICALLBACK DO_TICK_TIMER_1 (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
		{
		case EVENT_TIMER_TICK:

	if (Prog_Read_Cycle()==0)
	
			{
			 	 flag_err_comm++;
			 	 
			 	 if (flag_err_comm>3)
			 	 	{
			 	 	 flag_err_comm=0;
			 	 	 SetCtrlAttribute(panelHandle, PANEL_NUMBER_REG, ATTR_DIMMED,0);
	    		     SetCtrlAttribute(panelHandle, PANEL_QUANT_REG, ATTR_DIMMED,0);
	    		     SetCtrlAttribute(panelHandle, PANEL_ADDR_BLOCK, ATTR_DIMMED,0);
	    		     SetCtrlAttribute(panelHandle, PANEL_READ_REG, ATTR_DIMMED,0);
	    		     SetCtrlAttribute(panelHandle, PANEL_WRITE_REG, ATTR_DIMMED,0);
	    		     SetCtrlAttribute(panelHandle, PANEL_REG_2, ATTR_DIMMED,0);
		  		     SetCtrlAttribute(panelHandle, PANEL_REG_3, ATTR_DIMMED,0);
		  		     SetCtrlAttribute(panelHandle, PANEL_REG_4, ATTR_DIMMED,0);
		  		     SetCtrlAttribute(panelHandle, PANEL_REG_5, ATTR_DIMMED,0);
	    		     SetCtrlAttribute (panelHandle, PANEL_TIMER_1, ATTR_ENABLED, 0);
			 	 	 SetCtrlAttribute (panelHandle, PANEL_CYCLE_READ, ATTR_CTRL_VAL,0);
			 	 	 
			 	 	}
			}
			
			else  flag_err_comm=0;

			break;
		}
	return 0;
}

int CVICALLBACK D0_CYCLE_READ (int panel, int control, int event,  // 
		void *callbackData, int eventData1, int eventData2)
{
	 int c1=0;
	 unsigned char jj=0;
	 unsigned int c7;
	 
	     
	switch (event)
		{
		case EVENT_COMMIT:
	
	GetCtrlVal(panelHandle, PANEL_CYCLE_READ, &c1);
	    
	    if(c1==1)  
	    		 {
	    		   SetCtrlAttribute(panelHandle, PANEL_NUMBER_REG, ATTR_DIMMED,1);
	    		   SetCtrlAttribute(panelHandle, PANEL_QUANT_REG, ATTR_DIMMED,1);
	    		   SetCtrlAttribute(panelHandle, PANEL_ADDR_BLOCK, ATTR_DIMMED,1);
	    		   SetCtrlAttribute(panelHandle, PANEL_READ_REG, ATTR_DIMMED,1);
	    		   SetCtrlAttribute(panelHandle, PANEL_WRITE_REG, ATTR_DIMMED,1);
	    		   GetCtrlVal(panel, PANEL_QUANT_REG, &jj);	 //   
	    		   
	    		   c7=0;
	    		   
	    		   switch (jj)
	    		   
		  				{ case 1: SetCtrlAttribute(panelHandle, PANEL_REG_2, ATTR_DIMMED,1);
		  						  SetCtrlAttribute(panelHandle, PANEL_REG_3, ATTR_DIMMED,1);
		  						  SetCtrlAttribute(panelHandle, PANEL_REG_4, ATTR_DIMMED,1);
		  						  SetCtrlAttribute(panelHandle, PANEL_REG_5, ATTR_DIMMED,1);
		  						  SetCtrlVal(panelHandle, PANEL_REG_2, c7);
		  						  SetCtrlVal(panelHandle, PANEL_REG_3, c7);
		  						  SetCtrlVal(panelHandle, PANEL_REG_4, c7);
		  						  SetCtrlVal(panelHandle, PANEL_REG_5, c7);
		  						  break;
		  						  
		  				  case 2: SetCtrlAttribute(panelHandle, PANEL_REG_3, ATTR_DIMMED,1);
		  						  SetCtrlAttribute(panelHandle, PANEL_REG_4, ATTR_DIMMED,1);
		  						  SetCtrlAttribute(panelHandle, PANEL_REG_5, ATTR_DIMMED,1);
		  						  SetCtrlVal(panelHandle, PANEL_REG_3, c7);
		  						  SetCtrlVal(panelHandle, PANEL_REG_4, c7);
		  						  SetCtrlVal(panelHandle, PANEL_REG_5, c7);
		  				  		  break;
		  				  case 3: SetCtrlAttribute(panelHandle, PANEL_REG_4, ATTR_DIMMED,1);
		  						  SetCtrlAttribute(panelHandle, PANEL_REG_5, ATTR_DIMMED,1);
		  						  SetCtrlVal(panelHandle, PANEL_REG_4, c7);
		  						  SetCtrlVal(panelHandle, PANEL_REG_5, c7);
		  				  		  break;
		  				  case 4: SetCtrlAttribute(panelHandle, PANEL_REG_5, ATTR_DIMMED,1);
		  						  SetCtrlVal(panelHandle, PANEL_REG_5, c7);
		  				          break;
		  				}
	    		   
	    		   
	    		   SetCtrlAttribute (panelHandle, PANEL_TIMER_1, ATTR_ENABLED, 1);
	    		   //  
	    		  }

		   else   {
		   		   SetCtrlAttribute(panelHandle, PANEL_NUMBER_REG, ATTR_DIMMED,0);
	    		   SetCtrlAttribute(panelHandle, PANEL_QUANT_REG, ATTR_DIMMED,0);
	    		   SetCtrlAttribute(panelHandle, PANEL_ADDR_BLOCK, ATTR_DIMMED,0);
	    		   SetCtrlAttribute(panelHandle, PANEL_READ_REG, ATTR_DIMMED,0);
	    		   SetCtrlAttribute(panelHandle, PANEL_WRITE_REG, ATTR_DIMMED,0);
	    		   SetCtrlAttribute(panelHandle, PANEL_REG_2, ATTR_DIMMED,0);
		  		   SetCtrlAttribute(panelHandle, PANEL_REG_3, ATTR_DIMMED,0);
		  		   SetCtrlAttribute(panelHandle, PANEL_REG_4, ATTR_DIMMED,0);
		  		   SetCtrlAttribute(panelHandle, PANEL_REG_5, ATTR_DIMMED,0);
	    		   
	    		   SetCtrlAttribute (panelHandle, PANEL_TIMER_1, ATTR_ENABLED, 0);
	    		   //  
	    		   
		   		  }
		   		   
		
		

			break;
		}
	return 0;
}

int CVICALLBACK DO_WRITE_REG (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	 int c1=0;
	 unsigned char jj=0;
	 unsigned int c7;
	 unsigned char c4=0, j=0, i=0;
	 unsigned int c5=0;
	 

	switch (event)
		{
		case EVENT_COMMIT:

	       
			    
			   GetCtrlVal(panelHandle, PANEL_ADDR_BLOCK, &c4);	 //  
			   buf[0]=c4;
			   buf[1]=16;	//   (16- )
			   buf[2]=0;   //   ( 0)
			   GetCtrlVal(panelHandle, PANEL_NUMBER_REG, &c4);	 //  
	           buf[3]=c4;
			   buf[4]=0;   //    ( 0)  	
			   GetCtrlVal(panelHandle, PANEL_QUANT_REG, &c4);	 //   
			   buf[5]=c4;
			   buf[6]=2*c4;//   ( 2    )
			   
			   j=0;
			   for (i=0; i<c4; i++)
		  			{
		  				switch (i)
		  					 {
		  					 
		  				case 0x00: GetCtrlVal(panelHandle, PANEL_REG_1, &c7);
		  						break;
		  						
		  				case 0x01: GetCtrlVal(panelHandle, PANEL_REG_2, &c7);
		  						break;
		  						
		  				case 0x02: GetCtrlVal(panelHandle, PANEL_REG_3, &c7);
		  						break;
		  						
		  				case 0x03: GetCtrlVal(panelHandle, PANEL_REG_4, &c7);
		  						break;
		  						
		  				case 0x04: GetCtrlVal(panelHandle, PANEL_REG_5, &c7);
		  						break;		
		  						
		  					  }	
		  			   buf[7+j]=(c7>>8); buf[7+j+1]=c7;
		  			   j+=2;
		  			
		  			}
			
                 if (Simple_R_T(7+buf[6],6,1)!=0)	
		            {
		               if ((buf_Rx[0]==buf[0])&&(buf_Rx[1]==buf[1])&&(buf_Rx[2]==buf[2])&&
		             	 (buf_Rx[3]==buf[3])&&(buf_Rx[4]==buf[4])&&(buf_Rx[5]==buf[5]))
		  		          {  
		  		          }
		  		       else
		  		       {
		  		          SetCtrlVal(panelHandle, PANEL_LED_ERROR, 1); //:   
				          Delay(0.4);
				          SetCtrlVal(panelHandle, PANEL_LED_ERROR, 0);
		  		       }
		  
		            }
		            
		            
			break;
		}
	return 0;
}


int CVICALLBACK DO_READ_REG (int panel, int control, int event, //  MODBUS
		void *callbackData, int eventData1, int eventData2)
{
	unsigned char c4=0, j=0, i=0;
	unsigned int c5=0;
	
	

	switch (event)
		{
		case EVENT_COMMIT:

 

    
    
    GetCtrlVal(panelHandle, PANEL_ADDR_BLOCK, &c4);	 //  
	buf[0]=c4;
	buf[1]=3;	//   (3- )
	buf[2]=0;   //   ( 0)
	GetCtrlVal(panelHandle, PANEL_NUMBER_REG, &c4);	 //  
	buf[3]=c4;
	buf[4]=0;   //    ( 0)  	
	GetCtrlVal(panelHandle, PANEL_QUANT_REG, &c4);	 //   
	buf[5]=c4;
	
	
	
	
	
	if (Simple_R_T(6,3+(2*buf[5]),1)!=0)	
		  {
		  if ((buf_Rx[0]==buf[0])&&(buf_Rx[1]==buf[1])&&(buf_Rx[2]==(2*buf[5])))
		  		{  j=0;
		  		
		  		for (i=0; i<buf[5]; i++)
		  			{
		  			c5=(buf_Rx[3+j]<<8)+ buf_Rx[4+j];
		  			
		  			switch (j)
		  				{ case 0: SetCtrlVal(panelHandle, PANEL_REG_1, c5); break;
		  				  case 2: SetCtrlVal(panelHandle, PANEL_REG_2, c5); break;
		  				  case 4: SetCtrlVal(panelHandle, PANEL_REG_3, c5); break;
		  				  case 6: SetCtrlVal(panelHandle, PANEL_REG_4, c5); break;
		  				  case 8: SetCtrlVal(panelHandle, PANEL_REG_5, c5); break;  
		  				}
		  				
		  			  j+=2;	
		  			}
		  		
		  		
		  		}
		  		else
		  		{
		  		 SetCtrlVal(panelHandle, PANEL_LED_ERROR, 1); //:   
				 Delay(0.4);
				 SetCtrlVal(panelHandle, PANEL_LED_ERROR, 0);
		  		}
		  
		  }
	


			break;
		}
	return 0;
}
