//   
//  8051F0007,   7.3728 

#include <c8051f000.h>                 
#include <stdio.h>



    //    UART
#define BAUDRATE   9600              //   , 
#define SYSCLK     7372800          //  , 
#define CLK_ADC    250 //  .      3  
                       //    2  + .

//  16- 
sfr16 DP       = 0x82;                 // data pointer
sfr16 TMR3RL   = 0x92;                 // Timer3 reload value
sfr16 TMR3     = 0x94;                 // Timer3 counter
sfr16 RCAP2    = 0xca;                 // Timer2 capture/reload
sfr16 T2       = 0xcc;                 // Timer2


extern unsigned char idata current_ADC_input ; 


void SYSCLK_Init (void)           //  
  {
   unsigned int i;                //  

   OSCXCN = 0x67;                 //   

   for (i=0; i < 3000; i++) WDTCN = 0xa5;    //   

   do 
		{
		 WDTCN = 0xa5; //   
	    }
   while ((OSCXCN & 0x80)==0) ;   //   

   OSCICN = 0x88;                 //    
  }


void PORT_Init (void)      //   -.
{

   XBR0    = 0x04;                     // Enable UART0
   XBR1    = 0x00;
   XBR2    = 0xc0;                     //   , 
										// 
   P0=0x03;				//   UART  
   PRT0CF = 0x0d;          //  ""  "-"
							// -  
   P1=0x00;				//   
   PRT1CF = 0x00;          // -
   P2=0x00;				//   
   PRT2CF = 0x00;          // -
   P3=0x00;				//   
   PRT3CF = 0x00;          // -

}


void UART0_Init (void)   // UART.    -  1.
		//   0,      (3.5 .)
{  unsigned int temp_0=0;

   SCON    = 0xD8;                     //  1,  , 9- UART.
									   // 9-   1
   PCON|=0x80;
   TMOD    = 0x20;                     // TMOD: timer 1, mode 2, 8-bit reload
   TH1    = -(SYSCLK/BAUDRATE/16);     // set Timer1 reload value for baudrate
   TR1    = 1;                         //   1  UART
   CKCON |= 0x10;                      //       1
   ES=1;	                           //   UART

   TMOD|=0x01;				//   0 (  /12)
   							//   16-   
   TF0=0;
   ET0=1;  //      0 (  ).
   

}


void Timer3_Init (void) //  3 
{						//      4 .

   TMR3RL  = 65535 - SYSCLK/(12*CLK_ADC);

   TMR3    = 65535 - SYSCLK/(12*CLK_ADC); 

   TMR3CN |= 0x04;                    //   3
									//  /12
}



void ADC0_Init (void) //   (    3)
{
   REF0CN = 0x06;          //  ,   
   AMX0CF = 0x03;		//       .
   ADC0CF = 0x81;       // ADC conversion clock = SYSCLK/16,   .  - 

   AMX0SL = 0x00;      //       ( )
   current_ADC_input=0;

   ADC0CN = 0x84;                      //  ,   
                                       //  
   EIE2 |= 0x02;                       //    
}


void init_peripherial (void)       //   

     {
	   WDTCN = 0xff;		//    
       WDTCN = 0xa5;            //   
       SYSCLK_Init ();
       PORT_Init ();
       UART0_Init ();
	   Timer3_Init ();
       ADC0_Init ();
	   EA=1;					//   

     }
