//        
//  
//  8051F007,   7.3728 

//-----------------------------------------------------------------------------
// Includes
//-----------------------------------------------------------------------------

#include <c8051f000.h>                 // SFR declarations
#include <stdio.h>
#include <math.h>


#define const_filter  (5)    //     
//     (2, 4, 8, 32, 64, 128, 256).   
// (T^0.5)*CLK_ADC/3,  T -    .
#define count_max_preobr  (28) // ,  ,   
 //     .    
 //   1.5/CLK_ADC ( )  3/CLK_ADC  . 
 //  0.16  0.3  .

#define count_transmit_max_int (5) //         
//   (        ).   
//        (   3.5 ).
//   1...255.    20  (   23.5 ).
//     1/CLK_ADC  .  .

						

//  B1    
#define B_d(Nmax, ks) (1/(4*ks*Nmax))


//  16- 
sfr16 ADC0     = 0xbe;                 // ADC0 data

extern void init_peripherial (void);

extern unsigned char write_coeff(unsigned char *, unsigned int *);

//  
unsigned char idata current_ADC_input=0; //,   ,   
// 0 -    ( );
// 1 -    ( Y);
// 2 - ;

unsigned char idata adc_par_ready=0; //    
// (   ) 0 -    1 -  0, 2 -  1, 3 -  2.

signed int xdata adc_filter[]={0x0000,0x0000}; //  
						 //      Y  
signed long adc_filter_temper=0;  //   ()

unsigned int xdata count_preobr[]={0x00,0x00,0x00}; // , 
//     , , .

//  MODBUS       !
						      //  00h     01h    02h   03h    04h     05h   06h    07h 
unsigned int xdata reg_modbus[]={0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000};

//    
//								  04h    05h    06h    07h 
unsigned int code reg_default[]={10000, 10000, 10000, 10000};

//    MODBUS: 0 -  , 1 -     
                                     // 00h  01h  02h  03h  04h   05h  06h  07h
unsigned char code status_reg_modbus[]={0x00,0x00,0x00,0x00,0x01,0x01,0x01,0x01};

unsigned char addr_modbus=0;

//    UART

unsigned int idata Timer1_reload=63071; //    (3.5 )
//     65535-(38.5*SYSCLK/(12*BAUDRATE)).

//   B1    
float code  B1=B_d(32767, 0.2);
float xdata  gx=0, gy=0; //       Y
float xdata angle_fl; //    
float code pi=3.141592654;

unsigned char idata rejim_uart=0; //   UART
//0 - UART  
//1 - UART  
unsigned char idata count_byte_rx=0; //  
//  
unsigned char idata flag_rx=0; //   1 -  ()
//:   ,0 -   .
unsigned char idata quant_byte_tx=0; //   .  (0 -  )
//  
unsigned char idata count_byte_tx=0; //  
//  
unsigned char idata flag_tx=0; //   1 -  ()
//:   ,0 -   .

unsigned char xdata flag_rec=0; //    1 - 
//0 -  .
unsigned int xdata timer_rec=0; // ""     
// ( )
unsigned int xdata error_rec=0; //     
unsigned char xdata count_rec=0; //  

unsigned char xdata rx_buf[30]; //   (. 30 )

unsigned char xdata tx_buf[30]; //   (. 30 )

//   

void ADC0_ISR (void) interrupt 15 using 1  //    
   {

switch (current_ADC_input)
             {
		case 0x00: adc_par_ready=1; AMX0SL=0x02;
				   current_ADC_input=1;
			break;

		case 0x01: adc_par_ready=2; AMX0SL=0x08;
				   current_ADC_input=2;
			break;

		case 0x02: adc_par_ready=3; AMX0SL=0x00;
				   current_ADC_input=0;
			break;
             }
		ADCINT = 0;  //    
    }

void UART_ISR (void) interrupt 4 using 1  //  / UART
   {
	if (rejim_uart==0)
		{   //    

		
    if (count_byte_rx<29) 
			{ rx_buf[count_byte_rx]=SBUF;
   	    	  count_byte_rx++;
			} 
				else
			{ count_byte_rx=0; //  .  

			}
	 	TR0=0;
		TL0=Timer1_reload; //  
		TH0=(Timer1_reload>>8);
		TR0=1;

		}
			else
		{   //    


if (count_byte_tx<quant_byte_tx)
		  { SBUF=tx_buf[count_byte_tx];
			count_byte_tx++;
		  }
			else
		  {
			rejim_uart=0; //  ,  .
			REN=1; // 
			P0&=0xfb;
			count_byte_tx=0;
			quant_byte_tx=0;
			count_byte_rx=0; //   
		  }
	
		}

	RI=0; //    	
	TI=0; //    

   }

void TIMER0_ISR (void) interrupt 1 using 1  //   0 ( )
   {

if (count_byte_rx<8) count_byte_rx=0; //  ( 8 ) 
								//  
		else
			{	flag_rx=1; //    (   . )
				REN=0; // 
			}
    TR0=0;  //   0
	TF0=0;  //  
   }

   
 //  CRC (16-)  MODBUS

unsigned int CRC_Calc16(unsigned char *b, unsigned char N)
{
unsigned short int crc;
unsigned char i;
unsigned int j;

crc=0xffff;

for(i=0; i<N; i++)
 {
  crc = crc ^ (unsigned int)b[i];
  for(j=0;j<8;j++)
   {
   if((crc & 0x0001)==1) 
		{	crc>>=1;
			crc ^= 0xa001;
		}
     else crc >>= 1;
   }

 }

crc=(crc<<8)+(crc>>8); //  

return crc;
}


//-----------------------------------------------------------------------------
unsigned char test_modbus(void) //    1-  -  
	{
if (rx_buf[0]!=addr_modbus) return 1;	//    MODBUS 
if (rx_buf[2]!=0) return 1;				//   :  HI  .  HI (   0
if (rx_buf[4]!=0) return 1;
if (rx_buf[5]>5) return 1; // .   1  -   5.
if (rx_buf[5]==0) return 1; //   0.
if ((rx_buf[3]+(rx_buf[5]-1))>0x07) return 1; //   
return 0;
						
	}

//-----------------------------------------------------------------------------

void main (void) 
 { 

	signed long xdata FDI_I[3], FDI_II[3], k1, k2;
	unsigned int xdata k3;
	signed int xdata k4;
	float xdata k5;
	unsigned char i,j,jj,count_transmit=0; 
	unsigned char code *read_byte_coeff;
   
    init_peripherial ();   //  

    // ,      . (   
//0FFFF,        (10000))


read_byte_coeff=(unsigned char code*)0x6000; // 

for (i=0; i < 4; i++)
	{
k3=((unsigned int)(*read_byte_coeff))<<8;
read_byte_coeff++;
k3+=(*read_byte_coeff);
read_byte_coeff++;
if (k3!=0xffff) reg_modbus[0x04+i]=k3;
	else
		{   reg_modbus[0x04+i]=reg_default[i];
		}

	}


addr_modbus=1; // MODBUS     



	while (1)
	{

    if (adc_par_ready!=0)  //   .   (  ).
		{

				if (count_transmit==count_transmit_max_int) 
						{ P0|=0x04;		//   
						  count_transmit=0;
 						  rejim_uart=1;  // 
		  				  SBUF=tx_buf[0]; // 
                          count_byte_tx=1;
						}
				if (count_transmit>0) count_transmit++;

		if (adc_par_ready==3)
			{
		  k3=(ADC0<<4);
		  k1 = (((unsigned long) k3) << 15) - FDI_I[2]; //    
		  k2 = k1 >> const_filter;        // ( )
		  k2>>=1; //   2  
		  FDI_I[2] += k2;
		  adc_filter_temper=(FDI_I[2]>>15)+1;
				//     


          if (count_preobr[2]<count_max_preobr) count_preobr[2]++;
					else
						{  count_preobr[2]=0;						 
						  k4=(adc_filter_temper-50847)/187;  //   (AN103)

		  if (k4>0) //   e 01h MODBUS
						reg_modbus[0x01]=k4;
					else
						  {k3=-k4;
						   reg_modbus[0x01]=(~k3)+1;
						  }
			
						}

			adc_par_ready=0; // 

			}
				else
			{

			
			
          if (ADC0<=0x07ff) k1=((unsigned long)ADC0)<<20;   //     2
			
				else {   k1=((unsigned long)(~ADC0+1))<<20; k1=-k1; }	

          k1 -= FDI_I[adc_par_ready-1]; //   
		  k2 = k1 >> const_filter;
		  FDI_I[adc_par_ready-1] += k2;

		  k1 = FDI_I[adc_par_ready-1] - FDI_II[adc_par_ready-1]; //   
		  k2 = k1 >> const_filter;
		  FDI_II[adc_par_ready-1] += k2;
          adc_filter[adc_par_ready-1]=(FDI_II[adc_par_ready-1]>>16)+1; // 
							//  

		  if (adc_filter[adc_par_ready-1]>0) //    MODBUS
						reg_modbus[adc_par_ready+0x01]=adc_filter[adc_par_ready-1];
					else
						{k3=-adc_filter[adc_par_ready-1];
						 reg_modbus[adc_par_ready+0x01]=(~k3)+1;
						}

		  if (count_preobr[0]<count_max_preobr) 				    
					{
					count_preobr[0]++;						
					}
					else
						{  count_preobr[0]=0;

						//    
					gx=1-((float)reg_modbus[0x04]/10000);
					gx+=B1*(float)adc_filter[0]*(float)reg_modbus[0x05]/10000;
					gy=1-((float)reg_modbus[0x06]/10000);
					gy+=B1*(float)adc_filter[1]*(float)reg_modbus[0x07]/10000;


					if (gx>1) gx=1;  //    
					if (gx<-1) gx=-1;
					if (gy>1) gy=1;
					if (gy<-1) gy=-1;

							j=0;
						if ((gx==0)||(gy==0))
								{
							j=0xff;
						if ((gx==0)||(gy>0)) angle_fl=0;  //    
						     else
								  {
								if ((gx==0)||(gy<0)) angle_fl=-pi;
									else
										{
									  if ((gy==0)||(gx<0)) angle_fl=-pi/2;
											else
												{
												angle_fl=pi/2;
												}
										}
								  }
								}
					
						if (j==0)
							    {
							if(fabs(gx)<fabs(gy)) //    -179.9...+180.0 .	
									{
									angle_fl=atan(gx/gy);
									  if (gy<0)
										{
										  if (gx<0) angle_fl=-pi+angle_fl;
											else angle_fl=pi+angle_fl;

										}
				

									}
									else
									{
									angle_fl=atan(gy/gx);
									if (gx<0) angle_fl=(-pi/2)-angle_fl;
											else angle_fl=(pi/2)-angle_fl;
									}

		
							    }
						
													//     .
						if (angle_fl>=0) reg_modbus[0x00]=(unsigned int)(1800*angle_fl/pi); 
							else 
								{
								k5=-angle_fl;
								reg_modbus[0x00]=(unsigned int)(1800*k5/pi);
								reg_modbus[0x00]=(~reg_modbus[0x00])+1;
								}							


						}

            adc_par_ready=0; // 

       		}
			
		}        
       
 WDTCN = 0xa5;            //   

 if (flag_rx==1) //     UART

	 {  

 	  k3=(((unsigned int) rx_buf[count_byte_rx-2])<<8)+rx_buf[count_byte_rx-1];
	  if (CRC_Calc16(rx_buf, count_byte_rx-2)!=k3)            
			{ 					//  CRC
				count_byte_rx=0;
				REN=1; // 
			   
			}
		else
			{
	  if (test_modbus()==1) //     MODBUS 
				{      
					count_byte_rx=0;
					REN=1; // 
				}
				else
				 { //   -   CRC 
			switch (rx_buf[1])
				  {
				   case 0x03:  //     
								//    MODBUS
									
									tx_buf[0]=rx_buf[0]; //  
									tx_buf[1]=rx_buf[1]; //  
  									tx_buf[2]=(rx_buf[5]<<1); //  
										j=0;
									for (i=rx_buf[3]; i < (rx_buf[3]+rx_buf[5]); i++)
										{ tx_buf[3+j]=(reg_modbus[i]>>8);  //     
										  tx_buf[4+j]=reg_modbus[i];  //    
										  j+=2;
										}
 										  k3=CRC_Calc16 (tx_buf,3+tx_buf[2]); //  CRC
										  tx_buf[3+j]=(k3>>8);
										  tx_buf[4+j]=k3;                                          
										  quant_byte_tx=5+tx_buf[2];//  
										  count_transmit++;                                                                     
				   break;
							
				   case 0x10:  //     
							jj=0xff;
 				  			for (i=rx_buf[3]; i < (rx_buf[3]+rx_buf[5]); i++)

									{ //  ,  
										if (status_reg_modbus[i]!=1)	jj=0;
									}

								 if (jj!=0)
									{   //       
													if(write_coeff(rx_buf, reg_modbus)==0)
														{
														    //  
															P0|=0x04;		//   
															for (i=0; i < 6; i++) tx_buf[i]=rx_buf[i];
 															k3=CRC_Calc16 (tx_buf,6); //  CRC
										  					tx_buf[6]=(k3>>8);
										  					tx_buf[7]=k3;                                          
										  					quant_byte_tx=8;//  8 
		  								  					count_transmit++;	
														}
															else
																{//     - 
										  			             count_byte_rx=0;
								          			             REN=1; // 
																}
									}
									else
										{ //  :     
										  count_byte_rx=0;
								          REN=1; // 
										}

							
								

				   break;

 				   default: count_byte_rx=0;//     
							 REN=1; // 
							 break;
				   }


				 }

			}	
		flag_rx=0; //   
     } 

	}
 
 }


