#include <pic.h>
#include "rs232.h"


unsigned char ERROR_Rs232;

void Init_Rs232()
{
// USART
//         

  RCSTA = 0b10010000;
//          7         - SPEN: Serial Port Enable bit
//           6        - RX9: 9-bit Receive Enable bit
//            5       - SREN: Single Receive Enable bit
//             4      - CREN: Continuous Receive Enable bit
//              3     - ADDEN: Address Detect Enable bit
//               2    - FERR: Framing Error bit
//                1   - OERR: Overrun Error bit
//                 0  - RX9D: 9th bit of received data (Can be parity bit)
  TXSTA = 0b00100100;
//          7         - CSRC: Clock Source Select bit
//           6        - TX9: 9-bit Transmit Enable bit
//            5       - TXEN: Transmit Enable bit  (1 = Transmit enabled)
//             4      - SYNC: USART Mode Select bit
//              3     - Unimplemented: Read as '0'
//               2    - BRGH: High Baud Rate Select bit (1 = High speed)
//                1   - TRMT: Transmit Shift Register Status bit
//                 0  - TX9D: 9th bit of transmit data. Can be parity bit.
  SPBRG = 25; //  (FOSC/(BAUDRATE*16))-1 ; baudrate=9600



//	BRGH = 1;	/* high baud rate */
//	SPBRG = 26;	/*   9600*/
//	SYNC = 0;	/* asynchronous */
//	SPEN = 1;	/* enable serial port pins */
//	CREN = 1;	/* enable reception */
//	SREN = 0;	/* no effect */
//	TXIE = 1;	/* enable tx interrupts */
	RCIE = 1;	/* enable rx interrupts */
//	TX9  = 0;	/* 8- or 9-bit transmission */
//	RX9  = 0;	/* 8- or 9-bit reception */
//	TXEN = 1;	/* enable the transmitter */
// RCIF = 0;
}


void ERR_Rs232 ()
{
	ERROR_Rs232=0;
	if(OERR)	/* re-enable after overrun error */
	{
		CREN = 0;
		CREN = 1;
		ERROR_Rs232=1;
	}
	if(FERR)	/* re-enable after overrun error */
	{
		ERROR_Rs232=RCREG;
		ERROR_Rs232=RCREG;
		ERROR_Rs232=1;
	}
}

void WriteChar_Rs232(unsigned char TxData)
{
 TXREG=TxData;
}

unsigned char ReadChar_Rs232()
{
 return RCREG;
}
/*
void ReadBlock_Rs232()
{
//unsigned char a;

//for (a=0;a<6;a++)
 {
//  while (!RCIF) continue;
//  ERR_Rs232 ();
//  Stat[a]=RCREG;
//  RCIF=0;
 }
}
*/
